import{randomBytes as K,createHash as P}from"crypto";import C from"base-x";import _ from"bad-words-next";import N from"bad-words-next/data/en.json";import F from"bad-words-next/data/es.json";import H from"bad-words-next/data/fr.json";import B from"bad-words-next/data/de.json";var m=class{constructor(e,t){this.status=e,typeof t=="string"?this.body={message:t}:t?this.body=t:this.body={message:`Error: ${e}`}}toString(){return JSON.stringify(this.body)}};function l(o,e){throw(!!1||!1)&&(isNaN(o)||o<400||o>599)?new Error(`HTTP error status codes must be between 400 and 599 \u2014 ${o} is invalid`):new m(o,e)}var J=new TextEncoder;var h=class{constructor(e,t,s,r){this.event=e;this.bucket=t;this.key=s;this.info=r}_name="";_cost=1;_anon=!1;_has="";_any=[];_all=[];anonymous(){return this._anon=!0,this}name(e){return this._name=e,this}cost(e){return e<1&&l(500,"API cost must be at least 1"),this._cost=e,this}has(e){return this._has=e,this}any(e){return this._any=e,this}all(e){return this._all=e,this}async limit(e){let{key:t,info:s}=this;if(!this._anon&&!t&&l(401,"Missing API Key"),t&&!this.info&&l(403,"Invalid API Key"),s){if(s.expires&&s.expires.getTime()<Date.now()&&l(403,"API Key Expired"),this._has.length&&!s.permissions.includes(this._has)&&l(403,"Missing Permission: "+this._has),this._all.length&&!this._all.every(i=>s.permissions.includes(i))){let i=this._all.filter(c=>!s.permissions.includes(c)).join(", ");l(403,"Missing Permissions: "+i)}if(this._any.length&&!this._any.some(i=>s.permissions.includes(i))){let i=this._any.join(", ");l(403,"Missing any Permission: "+i)}}let n=(s?.user||this.event.getClientAddress())+":"+this._name,a=await this.bucket.consume(n,e,this._cost);return this.event.setHeaders({"RateLimit-Limit":a.limit.toString(),"RateLimit-Remaining":a.remaining.toString(),"RateLimit-Reset":a.reset.toString(),"RateLimit-Policy":a.policy}),a.allowed||l(429,"Too Many Requests"),a}};var M="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",k=C(M),u=new _;u.add(N);u.add(F);u.add(H);u.add(B);var A=32,O={searchParam:"key",httpHeader:"x-api-key",cookie:"api-key"},x=class{constructor(e,t,s=O){this.storage=e;this.buckets=t;this.options=s}hashFromBytes(e){return P("sha256").update(e).digest("hex")}async generate(e){let t,s;do s=K(this.options.key_length??A),t=k.encode(s);while(u.check(t));let r=this.hashFromBytes(s);return await this.storage.put(r,e),{key:t,hash:r}}async validate(e){if(!e)return null;let t=k.decode(e),s=this.hashFromBytes(t),r=await this.storage.get(s);return r?{hash:s,...r}:null}async remove(e){return await this.storage.del(e)}async retrieve(e){return await this.storage.list(e)}async extract(e){let t=null,s=e.request.clone();return this.options.cookie&&(t=e.cookies.get(this.options.cookie)??null),this.options.httpHeader&&(t=s.headers.get(this.options.httpHeader)||t),this.options.searchParam&&(t=e.url.searchParams.get(this.options.searchParam)||t),this.options.custom&&(t=await this.options.custom(e,t)),t}handle=async e=>{let{event:t,resolve:s}=e,{locals:r}=t,n=await this.extract(t),a=await this.validate(n);return r.api=new h(t,this.buckets,n,a),await s(t)}};var pe=1,ue=60,me=3600,he=86400,de=604800,w=class o{constructor(e,t=1){this.rate=e;this.size=t;if(e<=0)throw"rate must be greater than 0";if(t<1)throw"size must be at least 1"}static parse(e){let s=/(?<rate>\d+)\s*\/\s*(?<unit>second|minute|hour|day|week)\s*(,\s*(?<size>\d+))?/gi.exec(e);if(!s)throw"unable to parse refill value "+e;let r=parseInt(s.groups.rate),n=o.unitToDenominator(s.groups.unit.toLowerCase()),a=parseInt(s.groups.size??"1");return new o(r/n,a)}static unitToDenominator(e){switch(e){case"second":return 1;case"minute":return 60;case"hour":return 3600;case"day":return 86400;case"week":return 604800;default:throw"unexpected unit"}}};var p=class{apply(e,t,s,r){let n=e.size-r,a=Math.floor(r),i=Math.max(t-r,0),c=i>0?Math.ceil(i/e.rate):0,f=`${e.size};w=${e.rate}`;return{allowed:s,limit:n,remaining:a,reset:c,policy:f}}};var b=class extends p{buckets=new Map;async consume(e,t,s=1){let r=Date.now(),n=this.buckets.get(e);n||(n={tokens:t.size,updated:r},this.buckets.set(e,n));let i=(r-n.updated)*t.rate/1e3;n.tokens=Math.min(t.size,n.tokens+i),n.updated=r;let c=n.tokens>=s;return c&&(n.tokens-=s),this.apply(t,s,c,n.tokens)}};import"redis";var v=class o extends p{constructor(t,s="bucket:",r="TokenBucket",n="consume"){super();this.redis=t;this.prefix=s;this.module=r;this.fname=n}async consume(t,s,r=1){let n=await this.redis.sendCommand(["TFCALL",`${this.module}.${this.fname}`,"0",this.prefix+t,s.size.toString(),s.rate.toString(),r.toString()]),a=!1,i=0;for(let c=0;c<n.length;c+=2){let f=n[c],g=n[c+1];switch(f){case"allowed":a=g===1;break;case"tokens":i=parseFloat(g);break}}return this.apply(s,r,a,i)}static async create(t,s="bucket:",r="TokenBucket",n="consume"){let a=`#!js name=${r} api_version=1.0
redis.registerFunction('${n}', (client, key, size, rate, count) => {
	const now = Date.now()

	let bucket = client.call('hgetall', key)
	if (bucket.updated) {
		const deltaMs = now - parseInt(bucket.updated)
		const deltaNo = deltaMs * rate / 1000

		bucket.tokens = Math.min(size, parseFloat(bucket.tokens) + deltaNo)
		bucket.updated = now
	} else {
		bucket = { tokens: size, updated: now }
	}

	const allowed = bucket.tokens >= count
	if (allowed) {
		bucket.tokens -= count
	}

	// calculate how many tokens, or fractions of a token, are needed for the bucket to be full
	const deltaNo = Math.max(size - bucket.tokens, 0)

	// calculate time until the bucket is full, based on refill rate
	const expire = deltaNo > 0 ? Math.ceil(deltaNo / rate) : 0

	client.call('hset', key, 'tokens', bucket.tokens.toString(), 'updated', bucket.updated.toString())
	client.call('expire', key, expire.toString())

	return {
		allowed,
		tokens: bucket.tokens,
	}
})`;return await t.sendCommand(["TFUNCTION","LOAD","REPLACE",a]),new o(t,s,r,n)}};var d=class{constructor(e=1024,t=3600){this.maxSize=e;this.ttl=t*1e3}cache=new Map;ttl;get(e){let t=this.cache.get(e);if(t){let{ts:s,value:r}=t;if(s>Date.now()-this.ttl)return this.cache.delete(e),this.cache.set(e,t),r;this.cache.delete(e)}}set(e,t){return this.cache.size>=this.maxSize&&this.cache.delete(this.cache.keys().next().value),this.cache.set(e,{ts:Date.now(),value:t})}del(e){this.cache.delete(e)}};var R=class{constructor(e,t=1024,s=3600){this.store=e;this.cache=new d(t,s)}cache;async put(e,t){return this.cache.set(e,t),await this.store.put(e,t)}async get(e){return this.cache.get(e)??await this.store.get(e)}async del(e){this.cache.del(e),await this.store.del(e)}async list(e){return this.store.list(e)}};var z={toFirestore:o=>{let{hash:e,...t}=o;return t},fromFirestore:o=>{let e=o.data(),t=e.expires?e.expires.toDate():null;return{hash:o.id,...e,expires:t}}},D=class{constructor(e,t="api"){this.firestore=e;this.name=t;this.collection=this.firestore.collection(this.name).withConverter(z)}collection;async put(e,t){await this.collection.doc(e).set({hash:e,...t})}async get(e){return(await this.collection.doc(e).get()).data()||null}async del(e){await this.collection.doc(e).delete()}async list(e){return(await this.collection.where("user","==",e).get()).docs.map(s=>s.data())}};var I=class{keys=new Map;async put(e,t){this.keys.set(e,t)}async get(e){return this.keys.get(e)??null}async del(e){this.keys.delete(e)}async list(e){return Array.from(this.keys.entries()).filter(([s,r])=>r.user===e).map(([s,r])=>({hash:s,...r}))}};import{ErrorReply as L,SchemaFieldTypes as y}from"redis";var S=class o{constructor(e,t){this.redis=e;this.prefix=t}static async create(e,t="api:"){try{await e.ft.info(t+"index")}catch(s){if(s instanceof L&&s.message==="Unknown index name")await e.ft.create(t+"index",{user:y.TAG,permissions:y.TAG,expires:y.NUMERIC},{ON:"HASH",PREFIX:t});else throw s}return new o(e,t)}async put(e,t){await this.redis.hSet(this.prefix+e,{user:t.user,name:t.name,description:t.description,permissions:t.permissions.join(","),...t.expires?{expires:t.expires.getTime()/1e3}:{}})}async get(e){let t=await this.redis.hGetAll(this.prefix+e);return t.name===null?null:{user:t.user,name:t.name,description:t.description,permissions:t.permissions.split(","),expires:t.expires?new Date(parseFloat(t.expires)*1e3):null}}async del(e){await this.redis.del(this.prefix+e)}async list(e){let t=/[,.?<>{}[\]"':;!@#$%^&()\-+=~|/\\ ]/g,s=e.replace(t,"\\$&");return(await this.redis.ft.search(this.prefix+"index",`@user:{${s}}`)).documents.map(a=>{let i=a.value;return{hash:a.id,user:i.user,name:i.name,description:i.description,permissions:i.permissions.split(","),expires:i.expires?new Date(parseFloat(i.expires)*1e3):null}})}};export{x as ApiKeys,he as DAY,D as FirestoreKeyStore,me as HOUR,I as InMemoryKeyStore,b as InMemoryTokenBucket,R as LruCacheKeyStore,ue as MINUTE,S as RedisKeyStore,v as RedisTokenBucket,w as Refill,pe as SECOND,p as TokenBucket,de as WEEK};
